// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the runbook property type.
    /// </summary>
    public partial class ContentHash
    {
        private string _algorithm;
        
        /// <summary>
        /// Required. Gets or sets the content hash algorithm used to hash the
        /// content.
        /// </summary>
        public string Algorithm
        {
            get { return this._algorithm; }
            set { this._algorithm = value; }
        }
        
        private string _value;
        
        /// <summary>
        /// Required. Gets or sets expected hash value of the content.
        /// </summary>
        public string Value
        {
            get { return this._value; }
            set { this._value = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ContentHash class.
        /// </summary>
        public ContentHash()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ContentHash class with required
        /// arguments.
        /// </summary>
        public ContentHash(string algorithm, string value)
            : this()
        {
            if (algorithm == null)
            {
                throw new ArgumentNullException("algorithm");
            }
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            this.Algorithm = algorithm;
            this.Value = value;
        }
    }
}
