// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// A setting that contains all of the configuration for the automated
    /// export of a database.
    /// </summary>
    public partial class AutomatedExportSetting
    {
        private DatabaseBackupOption _backupOption;
        
        /// <summary>
        /// Optional. The backup job options.
        /// </summary>
        public DatabaseBackupOption BackupOption
        {
            get { return this._backupOption; }
            set { this._backupOption = value; }
        }
        
        private BackupLocationProfile _blobStorageSetting;
        
        /// <summary>
        /// Optional. The blob storage settings, where the exported file will
        /// be written.
        /// </summary>
        public BackupLocationProfile BlobStorageSetting
        {
            get { return this._blobStorageSetting; }
            set { this._blobStorageSetting = value; }
        }
        
        private DatabaseServerCredential _databaseCredential;
        
        /// <summary>
        /// Optional. The credential for the server hosting the database.
        /// </summary>
        public DatabaseServerCredential DatabaseCredential
        {
            get { return this._databaseCredential; }
            set { this._databaseCredential = value; }
        }
        
        private bool _enabled;
        
        /// <summary>
        /// Optional. Specifies whether automated export is enabled for the
        /// resource.
        /// </summary>
        public bool Enabled
        {
            get { return this._enabled; }
            set { this._enabled = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AutomatedExportSetting class.
        /// </summary>
        public AutomatedExportSetting()
        {
        }
    }
}
