// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.StreamAnalytics.Models
{
    /// <summary>
    /// Condition applicable to the resource, or to the job overall, that
    /// warrant customer attention.
    /// </summary>
    public partial class DiagnosticCondition
    {
        private string _code;
        
        /// <summary>
        /// Optional. Gets the opaque diagnostic code.
        /// </summary>
        public string Code
        {
            get { return this._code; }
            set { this._code = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Optional. Gets the human-readable message describing the condition
        /// in detail. Localized in the Accept-Language of the client request.
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private System.DateTime? _since;
        
        /// <summary>
        /// Optional. Gets the UTC timestamp of when the condition started.
        /// Customers should be able to find a corresponding event in the ops
        /// log around this time.
        /// </summary>
        public System.DateTime? Since
        {
            get { return this._since; }
            set { this._since = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DiagnosticCondition class.
        /// </summary>
        public DiagnosticCondition()
        {
        }
    }
}
