// Code generated by Microsoft (R) AutoRest Code Generator 0.12.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading;
    using System.Threading.Tasks;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;

    /// <summary>
    /// Use these APIs to manage Azure Websites resources through the Azure
    /// Resource Manager. All task operations conform to the HTTP/1.1
    /// protocol specification and each operation returns an x-ms-request-id
    /// header that can be used to obtain information about the request. You
    /// must make sure that requests made to these resources are secure. For
    /// more information, see &lt;a
    /// href="https://msdn.microsoft.com/en-us/library/azure/dn790557.aspx"&gt;Authenticating
    /// Azure Resource Manager requests.&lt;/a&gt;
    /// </summary>
    public partial interface IWebSiteManagementClient
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// The management credentials for Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Subscription Id
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// API Version
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// Gets or sets the preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout for Long Running Operations.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }


        ICertificatesOperations Certificates { get; }

        IClassicMobileServicesOperations ClassicMobileServices { get; }

        IDomainsOperations Domains { get; }

        IGlobalModelOperations GlobalModel { get; }

        IGlobalDomainRegistrationOperations GlobalDomainRegistration { get; }

        IGlobalResourceGroupsOperations GlobalResourceGroups { get; }

        IHostingEnvironmentsOperations HostingEnvironments { get; }

        IManagedHostingEnvironmentsOperations ManagedHostingEnvironments { get; }

        IProviderOperations Provider { get; }

        IServerFarmsOperations ServerFarms { get; }

        ISitesOperations Sites { get; }

        ITopLevelDomainsOperations TopLevelDomains { get; }

        IUsageOperations Usage { get; }

    }
}
