// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Defines options to control Cross-Origin Resource Sharing (CORS) for an
    /// index.
    /// </summary>
    public partial class CorsOptions
    {
        /// <summary>
        /// Initializes a new instance of the CorsOptions class.
        /// </summary>
        public CorsOptions() { }

        /// <summary>
        /// Initializes a new instance of the CorsOptions class.
        /// </summary>
        public CorsOptions(IList<string> allowedOrigins, long? maxAgeInSeconds = default(long?))
        {
            AllowedOrigins = allowedOrigins;
            MaxAgeInSeconds = maxAgeInSeconds;
        }

        /// <summary>
        /// Gets the list of origins from which JavaScript code will be
        /// granted access to your index. Can contain a list of hosts of the
        /// form {protocol}://{fully-qualified-domain-name}[:{port#}], or a
        /// single '*' to allow all origins (not recommended).
        /// </summary>
        [JsonProperty(PropertyName = "allowedOrigins")]
        public IList<string> AllowedOrigins { get; set; }

        /// <summary>
        /// Gets or sets the duration for which browsers should cache CORS
        /// preflight responses. Defaults to 5 mintues.
        /// </summary>
        [JsonProperty(PropertyName = "maxAgeInSeconds")]
        public long? MaxAgeInSeconds { get; set; }

        /// <summary>
        /// Validate the object. Throws ArgumentException or ArgumentNullException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (AllowedOrigins == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AllowedOrigins");
            }
        }
    }
}
