// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.RemoteApp.Models;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// The application security principal details.
    /// </summary>
    public partial class SecurityPrincipal
    {
        private string _aadObjectId;
        
        /// <summary>
        /// Optional. For OrgId principals, the principal's Azure
        /// ActiveDirectory object ID
        /// </summary>
        public string AadObjectId
        {
            get { return this._aadObjectId; }
            set { this._aadObjectId = value; }
        }
        
        private string _description;
        
        /// <summary>
        /// Optional. The security principal description.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. The security principal name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private PrincipalType _securityPrincipalType;
        
        /// <summary>
        /// Optional. The security principal type.
        /// </summary>
        public PrincipalType SecurityPrincipalType
        {
            get { return this._securityPrincipalType; }
            set { this._securityPrincipalType = value; }
        }
        
        private PrincipalProviderType _userIdType;
        
        /// <summary>
        /// Optional. The security principal provider type.
        /// </summary>
        public PrincipalProviderType UserIdType
        {
            get { return this._userIdType; }
            set { this._userIdType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SecurityPrincipal class.
        /// </summary>
        public SecurityPrincipal()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the SecurityPrincipal class with
        /// required arguments.
        /// </summary>
        public SecurityPrincipal(string name)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            this.Name = name;
        }
    }
}
