// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// The type of a template image.
    /// </summary>
    public enum TemplateImageStatus
    {
        /// <summary>
        /// The image upload is pending.
        /// </summary>
        UploadPending = 0,
        
        /// <summary>
        /// The image upload has started.
        /// </summary>
        UploadInProgress = 1,
        
        /// <summary>
        /// The image upload has completed succesfully.
        /// </summary>
        UploadComplete = 2,
        
        /// <summary>
        /// The image upload failed.
        /// </summary>
        UploadFailed = 3,
        
        /// <summary>
        /// The image import is in progress.
        /// </summary>
        ImportInProgress = 4,
        
        /// <summary>
        /// The image import failed.
        /// </summary>
        ImportFailed = 5,
        
        /// <summary>
        /// The image import has completed succesfully.
        /// </summary>
        ImportComplete = 6,
        
        /// <summary>
        /// The image validation failed.
        /// </summary>
        ValidationFailed = 7,
        
        /// <summary>
        /// The image is ready.
        /// </summary>
        Ready = 8,
        
        /// <summary>
        /// The image is corrupted.
        /// </summary>
        Corrupted = 9,
        
        /// <summary>
        /// The image is being deleted.
        /// </summary>
        Deleting = 10,
    }
}
