// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Management.StorSimple;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple
{
    /// <summary>
    /// This is an RESTFul API to manage you StorSimple Objects
    /// </summary>
    public static partial class DataContainerOperationsExtensions
    {
        /// <summary>
        /// The Begin Creating Volume Container operation creates a new volume
        /// container.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='containerDetails'>
        /// Required. Parameters supplied to the Begin Creating Volume
        /// Container operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static TaskResponse BeginCreating(this IDataContainerOperations operations, string deviceId, DataContainerRequest containerDetails, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDataContainerOperations)s).BeginCreatingAsync(deviceId, containerDetails, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Begin Creating Volume Container operation creates a new volume
        /// container.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='containerDetails'>
        /// Required. Parameters supplied to the Begin Creating Volume
        /// Container operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static Task<TaskResponse> BeginCreatingAsync(this IDataContainerOperations operations, string deviceId, DataContainerRequest containerDetails, CustomRequestHeaders customRequestHeaders)
        {
            return operations.BeginCreatingAsync(deviceId, containerDetails, customRequestHeaders, CancellationToken.None);
        }
        
        /// <summary>
        /// The Begin Deleting Volume Container operation deletes the specified
        /// volume container.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='dataContainerId'>
        /// Required. id of data container which needs to be deleted
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static TaskResponse BeginDeleting(this IDataContainerOperations operations, string deviceId, string dataContainerId, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDataContainerOperations)s).BeginDeletingAsync(deviceId, dataContainerId, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Begin Deleting Volume Container operation deletes the specified
        /// volume container.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='dataContainerId'>
        /// Required. id of data container which needs to be deleted
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// This is the Task Response for all Async Calls
        /// </returns>
        public static Task<TaskResponse> BeginDeletingAsync(this IDataContainerOperations operations, string deviceId, string dataContainerId, CustomRequestHeaders customRequestHeaders)
        {
            return operations.BeginDeletingAsync(deviceId, dataContainerId, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='containerDetails'>
        /// Required. Parameters supplied to the Create Volume Container
        /// operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static TaskStatusInfo Create(this IDataContainerOperations operations, string deviceId, DataContainerRequest containerDetails, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDataContainerOperations)s).CreateAsync(deviceId, containerDetails, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='containerDetails'>
        /// Required. Parameters supplied to the Create Volume Container
        /// operation.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static Task<TaskStatusInfo> CreateAsync(this IDataContainerOperations operations, string deviceId, DataContainerRequest containerDetails, CustomRequestHeaders customRequestHeaders)
        {
            return operations.CreateAsync(deviceId, containerDetails, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='dataContainerId'>
        /// Required. id of data container which needs to be deleted
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static TaskStatusInfo Delete(this IDataContainerOperations operations, string deviceId, string dataContainerId, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDataContainerOperations)s).DeleteAsync(deviceId, dataContainerId, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Required. device id
        /// </param>
        /// <param name='dataContainerId'>
        /// Required. id of data container which needs to be deleted
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Required. The Custom Request Headers which client must use.
        /// </param>
        /// <returns>
        /// Info about the async task
        /// </returns>
        public static Task<TaskStatusInfo> DeleteAsync(this IDataContainerOperations operations, string deviceId, string dataContainerId, CustomRequestHeaders customRequestHeaders)
        {
            return operations.DeleteAsync(deviceId, dataContainerId, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='dataContainerName'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the get of data containers.
        /// </returns>
        public static DataContainerGetResponse Get(this IDataContainerOperations operations, string deviceId, string dataContainerName, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDataContainerOperations)s).GetAsync(deviceId, dataContainerName, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='dataContainerName'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the get of data containers.
        /// </returns>
        public static Task<DataContainerGetResponse> GetAsync(this IDataContainerOperations operations, string deviceId, string dataContainerName, CustomRequestHeaders customRequestHeaders)
        {
            return operations.GetAsync(deviceId, dataContainerName, customRequestHeaders, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the list of data containers.
        /// </returns>
        public static DataContainerListResponse List(this IDataContainerOperations operations, string deviceId, CustomRequestHeaders customRequestHeaders)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IDataContainerOperations)s).ListAsync(deviceId, customRequestHeaders);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.StorSimple.IDataContainerOperations.
        /// </param>
        /// <param name='deviceId'>
        /// Optional.
        /// </param>
        /// <param name='customRequestHeaders'>
        /// Optional.
        /// </param>
        /// <returns>
        /// The response model for the list of data containers.
        /// </returns>
        public static Task<DataContainerListResponse> ListAsync(this IDataContainerOperations operations, string deviceId, CustomRequestHeaders customRequestHeaders)
        {
            return operations.ListAsync(deviceId, customRequestHeaders, CancellationToken.None);
        }
    }
}
